function DownloadPlugin() {
    var self = this;
    var _remoteUrl;
    var _localUrl;
    var _Deferred;

    //
    // Actually downloads the file
    //
    self.downloadFile = function(remoteUrl, localUrl) {
        _remoteUrl = remoteUrl;
        _localUrl = localUrl;

        // Temporary fix for RSS tickers
        _remoteUrl = _remoteUrl.replace("login.signagelive.com/getrss.asp", "sl.signagelive.com/Legacy/getrss.asp");
        _remoteUrl = _remoteUrl.replace("test.signagelive.com/getrss.asp", "test-sl.signagelive.com/Legacy/getrss.asp");

        console.log('File Download Plugin: Start download from: ' + _remoteUrl + ' to: ' + _localUrl);

        _Deferred = $.Deferred();

        // Download file using LG SDK copyFile method
        new Storage().copyFile(
            // Download Succeeded
            function(result) {
                console.log('File Download Plugin: Downloaded New File: ' + _localUrl);
                _Deferred.resolve(_remoteUrl, _localUrl);
            },
            // Download Failed
            function(result) {
                console.error('File Download Plugin: Error whilst downloading file from: ' + _remoteUrl + '. Error: [' + result.errorCode + '] ' + result.errorText);
                _Deferred.reject(_remoteUrl, _localUrl);
            },
            // Copy FilesOptions
            {
                source: _remoteUrl,
                destination: _localUrl
            }
        );

        return _Deferred.promise();
    };
}