var STATIC_SIGNAGELIVE_DOT_COM_URL = "https://static.signagelive.com/test.txt";
var DOWNLOADS_SIGNAGELIVE_DOT_COM_URL = "http://downloads.signagelive.com/test.txt";
var TIME_SIGNAGELIVE_DOT_COM_URL = "http://time.signagelive.com/api/localtime/?tzName=Europe/London"
var API_SIGNAGELIVE_DOT_COM_URL = "https://api.signagelive.com/v1.0/client/authenticate";
var APP_ID = "31f1cb7e";
var APP_KEY = "f4b89b065154e758fe63ef1f84b9cf4e";
var CLIENT_ID = "aaa-bbbb-cccc-ddddd-eeee";
var CLIENT_KEY = "69aa67e6-5032-4195-a9d9-b4efaa13dd12";

var _passes = 0;
var _failures = 0;

$(document).ready(function() {

    writeLine("Starting Signagelive Connection Test...");
    writeLine("<br/>");

    setTimeout(function() {
        // test API
        testAPISignageliveDotCom().always(function() {
            writeLine("<br/>");
            setTimeout(function() {
                // Test static
                testStaticSignageliveDotCom().always(function() {
                    writeLine("<br/>");
                    setTimeout(function() {
                        // Test time
                        testTimeSignageliveDotCom().always(function() {
                            writeLine("<br/>");
                            setTimeout(function() {
                                // Test downloads
                                testDownloadsSignageliveDotCom().always(function() {
                                    writeLine("<br/>");
                                    setTimeout(function() {
                                        writeLine("Signagelive Connection Test Completed. " + _passes + " Passes & " + _failures + " Failures.");
                                    }, 500);

                                    // Delete test files


                                });
                            }, 500);
                        });
                    }, 500);
                });
            }, 500);
        });
    }, 500);




});

// Test 1 - api.signagelive.com
function testAPISignageliveDotCom() {
    writeLine("Test 1/4: Attempting to authenticate with: " + API_SIGNAGELIVE_DOT_COM_URL);

    return $.ajax({
        url: API_SIGNAGELIVE_DOT_COM_URL,
        method: "POST",
        contentType: 'application/json',
        dataType: 'json',
        headers: {
            'X-SIGNAGELIVE-APP-ID': '31f1cb7e',
            'X-SIGNAGELIVE-APP-KEY': 'f4b89b065154e758fe63ef1f84b9cf4e',
            'X-SIGNAGELIVE-CLIENT-ID': 'aaa-bbbb-cccc-ddddd-eeee',
            'X-SIGNAGELIVE-CLIENT-KEY': '69aa67e6-5032-4195-a9d9-b4efaa13dd12'
        }
    }).done(function(data, textStatus, jqHXR) {
        writeLine("Test 1/4: Successfully authenticated with " + API_SIGNAGELIVE_DOT_COM_URL);
        writeLine("Test 1/4: Completed.");
        _passes++;
    }).fail(function(jqXHR, textStatus, errorThrown) {
        writeLine("Test 1/4: Error authenticating with " + API_SIGNAGELIVE_DOT_COM_URL + ". Error Code: " + jqXHR.status + ". Message: " + errorThrown);
        writeLine("Test 1/4: Failed.");
        _failures++;
    });
}

// Test 2 - static.signagelive.com
function testStaticSignageliveDotCom() {
    writeLine("Test 2/4: Attempting to download test file From: " + STATIC_SIGNAGELIVE_DOT_COM_URL);

    var downloader = new DownloadPlugin();
    return downloader.downloadFile(STATIC_SIGNAGELIVE_DOT_COM_URL, "file://internal/test1.txt")
        .done(function() {
            writeLine("Test 2/4: Successfully downloaded test file from: " + STATIC_SIGNAGELIVE_DOT_COM_URL);
            writeLine("Test 2/4: Completed.");
            _passes++;
        })
        .fail(function(error) {
            writeLine("Test 2/4: Error downloading test file from: " + STATIC_SIGNAGELIVE_DOT_COM_URL + ". Error: " + error);
            writeLine("Test 2/4: Failed.");
            _failures++;
        });
}

// Test 3 - time.signagelive.com
function testTimeSignageliveDotCom() {
    writeLine("Test 3/4: Attempting connection to: " + TIME_SIGNAGELIVE_DOT_COM_URL);

    return $.ajax({
        url: TIME_SIGNAGELIVE_DOT_COM_URL,
        method: "GET",
        contentType: 'application/json',
        dataType: 'json'
    }).done(function(data, textStatus, jqHXR) {
        writeLine("Test 3/4: Successfully connected to " + TIME_SIGNAGELIVE_DOT_COM_URL);
        writeLine("Test 3/4: Completed.");
        _passes++;
    }).fail(function(jqXHR, textStatus, errorThrown) {
        writeLine("Test 3/4: Error connecting to " + TIME_SIGNAGELIVE_DOT_COM_URL + ". Error Code: " + jqXHR.status + ". Message: " + errorThrown);
        writeLine("Test 3/4: Failed.");
        _failures++;
    });
}

// Test 4 - downloads.signagelive.com
function testDownloadsSignageliveDotCom() {
    writeLine("Test 4/4: Attempting to download test file from: " + DOWNLOADS_SIGNAGELIVE_DOT_COM_URL);

    var downloader = new DownloadPlugin();
    return downloader.downloadFile(DOWNLOADS_SIGNAGELIVE_DOT_COM_URL, "file://internal/test2.txt")
        .done(function() {
            writeLine("Test 4/4: Successfully downloaded test file from: " + DOWNLOADS_SIGNAGELIVE_DOT_COM_URL);
            writeLine("Test 4/4: Completed.");
            _passes++;
        })
        .fail(function(error) {
            writeLine("Test 4/4: Error downloading test file from: " + DOWNLOADS_SIGNAGELIVE_DOT_COM_URL + ". Error: " + error);
            writeLine("Test 4/4: Failed.");
            _failures++;
        });
}

function writeLine(text) {
    $('#output').append("<p>" + text + "</p>");
}